GuildedSetChannelColor_Frames = {
	ChatFrame1, ChatFrame2, ChatFrame3, ChatFrame4, ChatFrame5, ChatFrame6, ChatFrame7, ChatFrame8, ChatFrame9
};
-- Scorned/Renegade Legion color fix
function GuildedSetChannelColor( red, green, blue )
	if ( not ChanComm ) then
		return;
	end
	local id = ChanComm.chanID;
	if ( not id ) then
		return;
	end
	if ( not r ) then
		if ( not GuildedConfig ) then
			GuildedConfig = {};
		end
		if ( not GuildedConfig.color ) then
			GuildedConfig.color = { 0.2, 0.5, 0.2 };
		end
		red, green, blue = unpack(GuildedConfig.color);
	end
    local qwe = ChatTypeInfo["CHANNEL"..id];
    if ( not qwe ) then
    	return;
    end 
    qwe.r = red; 
    qwe.g = green; 
    qwe.b = blue;
    for k, v in GuildedSetChannelColor_Frames do
    	if ( v ) then
	    	v:UpdateColorByID(qwe.id, qwe.r, qwe.g, qwe.b);
	    end
    end
end

GuildedScornedLegion_ProfessionSpecializations = {
	Leatherworking = {
		Tribal = "Tribal";
		Stammes = "Tribal";
		Elemental = "Elemental";
		Elementargeist = "Elemental";
		Dragonscale = "Dragon";
	};
	Blacksmithing = {
		Armorsmith = "Armor";
		Weaponsmith = "Weapon";
		Waffenschmied = "Weapon";
		Axesmith = "Axe";
		Swordsmith = "Sword";
		Schwertschmied = "Sword";
		Hammersmith = "Hammer";
		Hammerschmied = "Hammer";
	};
};

GuildedScornedLegion_ProfessionSpecializationData = nil;

function GuildedScornedLegion_CacheProfessionSpecialization()
	GuildedScornedLegion_ProfessionSpecializationData = {};
	for i = 1, 60 do
		spellName = GetSpellName(i, "spell");
		if ( not spellName ) then
			break;
		end
		GuildedScornedLegion_ProfessionSpecializationData[i] = spellName;
	end
end

function GuildedScornedLegion_FindProfessionSpecialization(professionName)
	if ( not GuildedScornedLegion_ProfessionSpecializationData ) then
		GuildedScornedLegion_CacheProfessionSpecialization();
	end
	local spellName = nil;
	local spellList = GuildedScornedLegion_ProfessionSpecializationData;
	local list = GuildedScornedLegion_ProfessionSpecializations[professionName];
	if ( not list ) then
		return nil, nil;
	end
	local foundName = nil;
	local foundIndex = nil;
	for i = 1, 60 do
		spellName = spellList[i];
		if ( not spellName ) then
			break;
		end
		if ( string.find(spellName, professionName) ) then
			for k, v in list do
				if ( string.find(spellName, v) ) then
					foundName = v;
					foundIndex = i;
					break;
				end
			end
		end
	end
	return foundName, foundIndex;
end

GuildedScornedLegion_TranslateProfessionTable = {
	default = {
		Schneiderei = "Tailoring";
		Verzauberkunst = "Enchanting";
		Lederverarbeitung = "Leatherworking";
		Schmiedekunst = "Blacksmithing";
	};
	deDEDisabled = {
		Tailoring = "Schneiderei";
		Enchanting = "Verzauberkunst";
		Leatherworking = "Lederverarbeitung";
	};
};

function GuildedScornedLegion_TranslateProfession(skillName)
	local locale = "default";
	if ( GetLocale ) then
		local tmp = GetLocale();
		if ( GuildedScornedLegion_TranslateProfessionTable[tmp] ) then
			locale = tmp;
		end
	end
	local translateTable = GuildedScornedLegion_TranslateProfessionTable[locale];
	if ( not translateTable ) then
		return skillName;
	end
	if ( translateTable[skillName] ) then
		return translateTable[skillName];
	else
		return skillName;
	end
end

function GuildedGUI_NormalColorSet()
	local r,g,b = ColorPickerFrame:GetColorRGB();
	GuildedConfig.color = { r, g, b};
    if (GuildedPlayerIndex ~= nil) then
	    GuildedConfigAll[GuildedPlayerIndex] = GuildedConfig.getSaveData();
	end
	GuildedSetChannelColor();
	if(not ColorPickerFrame:IsVisible()) then
		ShowUIPanel(GuildedFrame);
	end
end

function GuildedGUI_ColorNilFunc(u,b,c)
	ShowUIPanel(GuildedFrame);
end

function Guilded_NormalColorSetButton()
	HideUIPanel(GuildedFrame);
	ColorPickerFrame.func = GuildedGUI_NormalColorSet;
	ColorPickerFrame.cancelFunc = GuildedGUI_ColorNilFunc;
	ColorPickerFrame.hasOpacity = false;
	--ColorPickerFrame.opacityFunc = CooldownCount_CosmosOpacity;
	local red, green, blue = unpack(GuildedConfig.color);
	ColorPickerFrame:SetColorRGB(red, green, blue);
	ColorPickerFrame.previousValues = {r = red, g = green, b = blue, opacity = 1};
	ColorPickerFrame:Show();
end



function GuildedTradersGUI_showDropdown(name)
	HideDropDownMenu(1);
	if ( not name ) then
		return;
	end
	if ( name == UnitName("player") ) then
		ToggleDropDownMenu(1, nil, PlayerFrameDropDown, "cursor");
	else
		local partyName = nil;
		for i = 1, 4 do
			partyName = "party"..i;
			if ( UnitExists(partyName) ) and ( name == UnitName(partyName) ) then
				ToggleDropDownMenu(1, nil, getglobal("PartyMemberFrame"..i.."DropDown"), "cursor");
				return;
			end
		end
		FriendsDropDown.initialize = FriendsFrameDropDown_Initialize;
		FriendsDropDown.displayMode = "MENU";
		FriendsDropDown.name = name;
		ToggleDropDownMenu(1, nil, FriendsDropDown, "cursor");
	end
end
    

function GuildedScornedLegion_onCraftButtonClick()
	GuildedScornedLegion_Saved_onCraftButtonClick();
	local button = arg1;
	if ( button ) and ( button == "LeftButton" ) then
	else
		GuildedTradersGUI_showDropdown(GuildedTradersFrameCraft.selectedName);
	end
end

function GuildedScornedLegion_SetupDefaultConfig()
	if ( GuildedScornedLegion_SetupDefaultConfig_Done ) then
		return;
	end
	if ( GuildedConfig ) then
		GuildedScornedLegion_SetupDefaultConfig_Done = true;
		GuildedConfig.valid = true;
	-- Scorned/Renegade Legion color fix
		GuildedConfig.color = { 0.2, 0.5, 0.2 };
	    GuildedConfig.slashChatCmd = GUILDED_DEFAULT_CHAT_SLASHCMD;
	-- Scorned/Renegade Legion fix
	    GuildedConfig.chanAlias = "Alliance";
	-- Scorned/Renegade Legion fix
	    GuildedConfig.chanName = "scornedlegion";
	-- Scorned/Renegade Legion fix
	    GuildedConfig.chanPwd = "";
	end
end

function GuildedScornedLegion_GuildedConfig_getSaveData()
	local saveData = GuildedScornedLegion_Saved_GuildedConfig_getSaveData();
	saveData.color = GuildedConfig.color;
	return saveData;
end

function GuildedScornedLegion_GuildedConfig_loadData(data)
	GuildedScornedLegion_Saved_GuildedConfig_loadData(data);
	if ( data ) then
		if ( data.color ~= nil ) then
			GuildedConfig.color = data.color;
		end
	end
end

function GuildedScornedLegion_joinGuilded(slashCmd, alias, name, pwd)
	local retValue = GuildedScornedLegion_Saved_joinGuilded(slashCmd, alias, name, pwd);
	if (retValue > 0) then
		if ( GuildedSetChannelColor ) then
       		GuildedSetChannelColor();
       	end
	end
	return retValue;
end


function GuildedScornedLegionCode_HookFunctions()
	if ( GuildedScornedLegionCode_HasHooked ) then
		return;
	end
	if ( not GuildedConfig ) or ( not GuildedTradersGUI ) or ( not Guilded ) then
		return;
	end
	if ( GuildedConfig ) then
		GuildedScornedLegion_Saved_GuildedConfig_getSaveData = GuildedConfig.getSaveData;
		GuildedConfig.getSaveData = GuildedScornedLegion_GuildedConfig_getSaveData;

		GuildedScornedLegion_Saved_GuildedConfig_loadData = GuildedConfig.loadData;
		GuildedConfig.loadData = GuildedScornedLegion_GuildedConfig_loadData;
	end
	if ( GuildedTradersGUI ) then
		GuildedScornedLegion_Saved_onCraftButtonClick = GuildedTradersGUI.onCraftButtonClick;
		GuildedTradersGUI.onCraftButtonClick = GuildedScornedLegion_onCraftButtonClick;
		
		local name = nil;
		local button = nil;
		for i = 1, 20 do
			name = "GuildedTradersFrameButton"..i;
			button = getglobal(name);
			button:RegisterForClicks("LeftButtonUp", "RightButtonUp");
		end
		
	end
	if ( Guilded ) then
		GuildedScornedLegion_Saved_joinGuilded = Guilded.joinGuilded;
		Guilded.joinGuilded = GuildedScornedLegion_joinGuilded;
	end
	GuildedScornedLegionCode_HasHooked = true;
end

function GuildedScornedLegionCode_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("GUILD_MOTD");
	GuildedScornedLegion_SetupDefaultConfig();
	GuildedScornedLegionDKP_Setup();
end

function GuildedScornedLegionCode_MotDUpdate()
	local motd = GetGuildRosterMOTD();
	if ( not motd ) then
		return false;
	end
	local str = "NewGPwd:"
	local index = string.find(motd, str);
	if ( index ) then
		local pwd = string.sub(motd, str, index+strlen(str));
		if ( not pwd ) then
			return false;
		end
		if ( GuildedConfig ) then
			GuildedConfig.chanPwd = pwd;
		    if (GuildedPlayerIndex ~= nil) then
			    GuildedConfigAll[GuildedPlayerIndex] = GuildedConfig.getSaveData();
			end
		end
	end
end

function GuildedScornedLegionCode_OnEvent()
	if ( event == "VARIABLES_LOADED" ) then
		GuildedScornedLegionCode_HookFunctions();
		GuildedScornedLegion_SetupDefaultConfig();
		GuildedSetChannelColor();
	end
	if ( event == "GUILD_MOTD" ) then
		GuildedScornedLegionCode_MotDUpdate();
	end
end


